string cvs_version = "$Id: install-roxen.pike,v 1.14 2000/04/04 21:00:49 peter Exp $";

int main(int argc, array(string) argv, mixed ... rest)
{
  string roxenpath="/usr/local", pikepath="/usr/local", tmp;
  int samedir;
  object ls = Stdio.Readline();

  /* Ask for installation dir (roxenpath) */
  write("[1mRoxen installation prefix (roxen will be added) [ "
	+roxenpath+" ][0m: ");
  tmp = ls->read();

  if(strlen(tmp))
  {
    roxenpath=tmp;
    pikepath=tmp;
  }

  /* Ask if the pike should be installed in roxen or in the normal
     runpath. Default: global*/

  while(1)
  {
    write("[1mInstall Pike separately? [ Y/n ][0m: ");
    tmp = ls->read();
    
    if(!strlen(tmp))
      break;
    else if(lower_case(tmp[0..0]) == "n") {
      samedir = 1;
      break;
    } else if( lower_case(tmp[0..0]) == "y" )
      break;
   }
    
  /* Conditionally ask for pike-path. Default: same as roxen-prefix */
  if(!samedir) {
    write("[1m Pike installation prefix [ "+pikepath+" ][0m: ");
    tmp = ls->read();
    
    if(strlen(tmp))
      pikepath=tmp;
  } else
    pikepath=roxenpath +"/roxen/server/pike";

  roxenpath += "/roxen";

  if(file_stat(roxenpath +"/server.old", 1)) {
    if(file_stat(roxenpath +"/server.older", 1))
      Stdio.recursive_rm(roxenpath +"/server.older");
    mv(roxenpath +"/server.old", roxenpath +"/server.older");
  }
  if(file_stat(roxenpath +"/server", 1))
    mv(roxenpath +"/server", roxenpath +"/server.old");

  //FIXME: Copy the local etc/enviroment

  /* Make dirs */
  Stdio.mkdirhier( roxenpath+"/server/bin/" );
  Stdio.mkdirhier( pikepath+"/" );    
  
  argv += ({ "prefix="+ pikepath });
  argc++;

  if(samedir) {
    argv += ({ "--traditional" });
  }else{
    argv += ({ "--new-style" });
  }
  argc++;

  string origdir = getcwd();
  string packagepath = combine_path(origdir,"..");
  array files = glob( "*.tar.gz", get_dir(packagepath) );
  foreach( files, string file ) {
    cd( packagepath );
    write("Installing package "+ (file-".tar.gz") +"...\n");
    //Really ugly, but we have no real packages yet.
    //This could be done by giving them the correct paths in the tars instead.
    //FIXME: Check tars returncode
    array tmp = array_sscanf(file, "%s-%s.tar.gz");
    string package=file-".tar.gz";
    if(sizeof(tmp))
      package=tmp[0];
    switch(package) {
     case "roxen":
       //FIXME: need to move away more old stuff.
       cd( roxenpath );
       Process.popen("gunzip < "+ packagepath+"/"+file +" | tar xf -");
     default:
       //       mkdir( combine_path(roxenpath, "platform") );
       //       cd( combine_path(roxenpath, "platform") );
       cd( roxenpath );       
       Process.popen("gunzip < "+ packagepath+"/"+file +" | tar xf -");
    }
  }
  cd( origdir );

  /* Roxen will now install. This might take some time */
  ((program)(getcwd()+"/bin/install.pike"))()->main(argc, argv, @rest);

  if(!file_stat(pikepath+"/bin/pike")){
    werror("FATAL: Pike binary not found!\n");
    exit(1);
  }

  Stdio.mkdirhier( roxenpath+"/server/bin/" ); 
  
  /* First try to get where our real pike is located */
  string realpike = pikepath+"/bin/pike";
  if(Stdio.is_link(realpike))
    realpike = readlink( pikepath+"/bin/pike" );
  else
    werror("WARNING: "+ realpike +" is not a link!\n");
  string roxenbin = roxenpath+"/server/bin/roxen";

  mixed err = catch {
    rm( roxenbin );
    hardlink( realpike, roxenbin );
  };
  if(err) {
    err = catch {
      rm( roxenbin );
      //FIXME: It is probably better to do a copy here instead.
      symlink( pikepath+"/bin/pike", roxenbin );
    };
  }
  if(err)
    werror("Unable to link pike binary! This is very bad!\n");

  cd( roxenpath+"/server" );
  write( getcwd() +"\n" );
  Process.create_process( ({"./create_configinterface"}) )->wait();
  Process.create_process( ({"./start"}) )->wait();
}
